"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _Rule2 = _interopRequireDefault(require("./Rule"));

var _crypto = require("crypto");

var _fs = _interopRequireDefault(require("fs"));

var _Verbosity = _interopRequireDefault(require("./Verbosity"));

var _es6Promisify = _interopRequireDefault(require("es6-promisify"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var HashRule = /*#__PURE__*/function (_Rule) {
  (0, _inherits2["default"])(HashRule, _Rule);

  var _super = _createSuper(HashRule);

  function HashRule(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, HashRule);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_make", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(context) {
        var hash, _assertThisInitialize, targets, promake, recipe, prerequisites, _targets2, target, _ref2, file, _iterator, _step, prerequisite, digest, lastDigest;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                hash = (0, _crypto.createHash)(_this.hashAlgorithm);
                _assertThisInitialize = (0, _assertThisInitialized2["default"])(_this), targets = _assertThisInitialize.targets, promake = _assertThisInitialize.promake, recipe = _assertThisInitialize.recipe;
                prerequisites = _this.prerequisites;
                _targets2 = (0, _slicedToArray2["default"])(targets, 1), target = _targets2[0];

                if (target) {
                  _context.next = 6;
                  break;
                }

                throw new Error('missing target');

              case 6:
                _ref2 = target, file = _ref2.file;

                if (!(typeof file !== 'string')) {
                  _context.next = 9;
                  break;
                }

                throw new Error('missing targets[0].file');

              case 9:
                _iterator = _createForOfIteratorHelper(prerequisites);
                _context.prev = 10;

                _iterator.s();

              case 12:
                if ((_step = _iterator.n()).done) {
                  _context.next = 20;
                  break;
                }

                prerequisite = _step.value;
                _context.next = 16;
                return promake._make(prerequisite, context);

              case 16:
                _context.next = 18;
                return prerequisite.updateHash(hash);

              case 18:
                _context.next = 12;
                break;

              case 20:
                _context.next = 25;
                break;

              case 22:
                _context.prev = 22;
                _context.t0 = _context["catch"](10);

                _iterator.e(_context.t0);

              case 25:
                _context.prev = 25;

                _iterator.f();

                return _context.finish(25);

              case 28:
                digest = hash.digest('hex');
                _context.prev = 29;
                _context.next = 32;
                return (0, _es6Promisify["default"])(_fs["default"].readFile)(file, 'utf8');

              case 32:
                lastDigest = _context.sent.trim();
                _context.next = 39;
                break;

              case 35:
                _context.prev = 35;
                _context.t1 = _context["catch"](29);

                if (!(_context.t1.code !== 'ENOENT')) {
                  _context.next = 39;
                  break;
                }

                throw _context.t1;

              case 39:
                if (!(lastDigest === digest)) {
                  _context.next = 42;
                  break;
                }

                promake.log(_Verbosity["default"].DEFAULT, 'Nothing to be done for', _this.toString(), 'hash:', lastDigest);
                return _context.abrupt("return");

              case 42:
                if (!recipe) {
                  _context.next = 46;
                  break;
                }

                promake.log(_Verbosity["default"].DEFAULT, 'Making', _this.toString(), 'hash:', lastDigest);
                _context.next = 46;
                return recipe((0, _assertThisInitialized2["default"])(_this));

              case 46:
                _context.next = 48;
                return (0, _es6Promisify["default"])(_fs["default"].writeFile)(file, digest, 'utf8');

              case 48:
                _this.lastFinishTime = Date.now();

              case 49:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[10, 22, 25, 28], [29, 35]]);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    var _targets = props.targets,
        _prerequisites = props.prerequisites;

    if (_targets.length !== 1 || typeof _targets[0].file !== 'string') {
      throw new Error('targets must contain a single FileResource');
    }

    var _iterator2 = _createForOfIteratorHelper(_prerequisites),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var prerequisite = _step2.value;
        if (typeof prerequisite.updateHash !== 'function') throw new Error("prerequisite lacks an updateHash function: ".concat(String(prerequisite)));
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    return _this;
  }

  return HashRule;
}(_Rule2["default"]);

exports["default"] = HashRule;
module.exports = exports.default;