"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var t = _interopRequireWildcard(require("typed-validators"));

var _Resource = require("./Resource");

var _FileResource = _interopRequireDefault(require("./FileResource"));

var _Rule = _interopRequireWildcard(require("./Rule"));

var _LastModifiedRule = _interopRequireDefault(require("./LastModifiedRule"));

var _HashRule = _interopRequireDefault(require("./HashRule"));

var _TaskResource = _interopRequireDefault(require("./TaskResource"));

var _promisifyChildProcess = require("promisify-child-process");

var _chalk = _interopRequireDefault(require("chalk"));

var _Verbosity = _interopRequireDefault(require("./Verbosity"));

var _lodash = _interopRequireDefault(require("lodash.padend"));

var _ExecutionContext = _interopRequireDefault(require("./ExecutionContext"));

var _handleChildProcessCleanup = _interopRequireDefault(require("./handleChildProcessCleanup"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

// const ResourcesType = (reify: Type<Array<string | BasicResource> | string | BasicResource>)
// const PrerequisitesType = (reify: Type<Array<string | BasicResource | Rule> | string | BasicResource | Rule>)
// const HashPrerequisitesType = (reify: Type<Array<string | BasicHashResource | Rule> | string | BasicHashResource | Rule>)
var ResourcesType = t.alias('Resources', t.oneOf(t.array(t.oneOf(t.string(), t.ref(function () {
  return _Resource.ResourceType;
}))), t.string(), t.ref(function () {
  return _Resource.ResourceType;
})));
var BasicResourceType = t.alias('BasicResource', t.record(t.any(), t.any()));
BasicResourceType.addConstraint(function (resource) {
  if (typeof resource.lastModified !== 'function' || resource.lastModified.length !== 0) return 'must have a lastModified method that takes no arguments';
});
var BasicHashResourceType = t.alias('BasicHashResource', t.record(t.any(), t.any()));
BasicHashResourceType.addConstraint(function (resource) {
  if (typeof resource.updateHash !== 'function' || resource.updateHash.length !== 1) return 'must have a updateHash method that takes one argument';
});
var PrerequisitesType = t.alias('Prerequisites', t.oneOf(t.array(t.oneOf(t.string(), t.ref(function () {
  return BasicResourceType;
}), t.ref(function () {
  return _Rule.RuleType;
}))), t.string(), t.ref(function () {
  return BasicResourceType;
}), t.ref(function () {
  return _Rule.RuleType;
})));
var HashPrerequisitesType = t.alias('Prerequisites', t.oneOf(t.array(t.oneOf(t.string(), t.ref(function () {
  return BasicHashResourceType;
}), t.ref(function () {
  return _Rule.RuleType;
}))), t.string(), t.ref(function () {
  return BasicHashResourceType;
}), t.ref(function () {
  return _Rule.RuleType;
})));

var Promake = /*#__PURE__*/function () {
  function Promake() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Promake);
    (0, _defineProperty2["default"])(this, "fileResources", new Map());
    (0, _defineProperty2["default"])(this, "taskResources", new Map());
    (0, _defineProperty2["default"])(this, "rules", new Map());
    (0, _defineProperty2["default"])(this, "verbosity", _Verbosity["default"].DEFAULT);
    (0, _defineProperty2["default"])(this, "_normalizeResource", function (resource) {
      if (typeof resource === 'string') {
        var normalized = new _FileResource["default"](resource);

        var file = _this.fileResources.get(normalized.file);

        if (!file) _this.fileResources.set(normalized.file, file = normalized);
        return file;
      }

      return resource;
    });
    (0, _defineProperty2["default"])(this, "_normalizePrerequisite", function (resource) {
      if (resource instanceof _Rule["default"]) return resource.targets;
      return _this._normalizeResource(resource);
    });
    (0, _defineProperty2["default"])(this, "_normalizeResources", function (resources) {
      ResourcesType.assert(resources, '', ['resources']);
      return Array.isArray(resources) ? resources.map(_this._normalizeResource) : [_this._normalizeResource(resources)];
    });
    (0, _defineProperty2["default"])(this, "_normalizePrerequisites", function (prerequisites) {
      var _ref;

      PrerequisitesType.assert(prerequisites, '', ['prerequisites']);
      if (Array.isArray(prerequisites)) return (_ref = []).concat.apply(_ref, (0, _toConsumableArray2["default"])(prerequisites.map(_this._normalizePrerequisite)));

      var normalized = _this._normalizePrerequisite(prerequisites);

      return Array.isArray(normalized) ? normalized : [normalized];
    });
    (0, _defineProperty2["default"])(this, "_normalizeHashPrerequisites", function (prerequisites) {
      var _ref2;

      HashPrerequisitesType.assert(prerequisites, '', ['prerequisites']);
      if (Array.isArray(prerequisites)) return (_ref2 = []).concat.apply(_ref2, (0, _toConsumableArray2["default"])(prerequisites.map(_this._normalizePrerequisite)));

      var normalized = _this._normalizePrerequisite(prerequisites);

      return Array.isArray(normalized) ? normalized : [normalized];
    });
    (0, _defineProperty2["default"])(this, "_normalizeName", function (name) {
      var result = _this.taskResources.get(name) || _this.fileResources.get(new _FileResource["default"](name).file);

      if (!result) throw new Error("no task or file found for ".concat(name));
      return result;
    });
    (0, _defineProperty2["default"])(this, "_make", /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resource, context) {
        var rule, time;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                rule = _this.rules.get(resource);

                if (rule) {
                  _context.next = 9;
                  break;
                }

                if (!(typeof resource.lastModified === 'function')) {
                  _context.next = 8;
                  break;
                }

                _context.next = 5;
                return resource.lastModified();

              case 5:
                time = _context.sent;

                if (!Number.isFinite(time)) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt("return", time);

              case 8:
                throw new Error("No rule found to make ".concat(resource.toString()));

              case 9:
                _context.next = 11;
                return rule.make(context);

              case 11:
                return _context.abrupt("return", resource.lastModified());

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref3.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "make", /*#__PURE__*/function () {
      var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(target) {
        var context,
            _args2 = arguments;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                context = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : new _ExecutionContext["default"]();
                if (typeof target === 'string') target = _this._normalizeName(target);
                _context2.next = 4;
                return _this._make(target, context);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x3) {
        return _ref4.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "log", function (verbosity) {
      var _console;

      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      if (_this.verbosity >= verbosity) (_console = console).error.apply(_console, [_chalk["default"].bold('[promake]')].concat(args)); // eslint-disable-line no-console
    });
    (0, _defineProperty2["default"])(this, "logStream", function (verbosity, stream) {
      if (_this.verbosity >= verbosity) stream.pipe(process.stderr);
    });
    (0, _defineProperty2["default"])(this, "_logChildProcess", function (child) {
      if (_this.verbosity <= _Verbosity["default"].QUIET) return;
      if (child.stdout) child.stdout.pipe(process.stdout);
      if (child.stderr) child.stderr.pipe(process.stderr);
    });
    (0, _defineProperty2["default"])(this, "exec", function (command) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var child = (0, _promisifyChildProcess.exec)(command, options);
      (0, _handleChildProcessCleanup["default"])(_this, child);
      if (_this.verbosity >= _Verbosity["default"].DEFAULT) console.error(_chalk["default"].gray('$'), _chalk["default"].gray(command)); // eslint-disable-line no-console

      _this._logChildProcess(child);

      return child;
    });
    (0, _defineProperty2["default"])(this, "spawn", function (command, argsOrOptions, options) {
      var _console2;

      var args = Array.isArray(argsOrOptions) ? argsOrOptions : [];

      if (argsOrOptions instanceof Object && !Array.isArray(argsOrOptions)) {
        options = argsOrOptions;
      }

      if (!options) options = {};

      function formatArg(arg) {
        if (/^[-_a-z0-9=./]+$/i.test(arg)) return _chalk["default"].gray(arg);
        return _chalk["default"].gray("'".concat(arg.replace(/'/g, "'\\''"), "'"));
      }

      var child = (0, _promisifyChildProcess.spawn)(command, args, options);
      (0, _handleChildProcessCleanup["default"])(_this, child);
      if (_this.verbosity >= _Verbosity["default"].DEFAULT) // eslint-disable-next-line no-console
        (_console2 = console).error.apply(_console2, [_chalk["default"].gray('$'), _chalk["default"].gray(command)].concat((0, _toConsumableArray2["default"])(args.map(formatArg))));

      _this._logChildProcess(child);

      return child;
    });
    (0, _defineProperty2["default"])(this, "rule", function (targets, prerequisites, recipe, options) {
      if (typeof prerequisites === 'function') {
        options = recipe;
        recipe = prerequisites;
        prerequisites = null;
      }

      if (!prerequisites && !recipe) {
        if (Array.isArray(targets)) throw new Error('You must pass only one target when looking up a rule');

        var _target = _this._normalizeResource(targets);

        var _rule = _this.rules.get(_target);

        if (!_rule) throw new Error("No rule found for ".concat(_target.toString()));
        return _rule;
      }

      var rule = new _LastModifiedRule["default"]({
        promake: _this,
        targets: _this._normalizeResources(targets),
        prerequisites: prerequisites ? _this._normalizePrerequisites(prerequisites) : [],
        recipe: recipe,
        runAtLeastOnce: Boolean(options && options.runAtLeastOnce)
      });

      var _iterator = _createForOfIteratorHelper(rule.targets),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _target2 = _step.value;
          if (_this.rules.has(_target2)) throw new Error("A rule for ".concat(_target2.toString(), " already exists"));

          _this.rules.set(_target2, rule);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return rule;
    });
    (0, _defineProperty2["default"])(this, "hashRule", function (algorithm, target, prerequisites, recipe, options) {
      var finalTarget = _this._normalizeResource(target);

      if (typeof prerequisites === 'function') {
        options = recipe;
        recipe = prerequisites;
        prerequisites = null;
      }

      if (!prerequisites && !recipe) {
        var _rule2 = _this.rules.get(finalTarget);

        if (!_rule2) throw new Error("No rule found for ".concat(target.toString()));
        if (!(_rule2 instanceof _HashRule["default"])) throw new Error("Rule for target is not a HashRule");
        return _rule2;
      }

      var rule = new _HashRule["default"]({
        hashAlgorithm: algorithm,
        promake: _this,
        targets: [finalTarget],
        prerequisites: prerequisites ? _this._normalizeHashPrerequisites(prerequisites) : [],
        recipe: recipe,
        runAtLeastOnce: Boolean(options && options.runAtLeastOnce)
      });

      var _iterator2 = _createForOfIteratorHelper(rule.targets),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _target3 = _step2.value;
          if (_this.rules.has(_target3)) throw new Error("A rule for ".concat(_target3.toString(), " already exists"));

          _this.rules.set(_target3, rule);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      return rule;
    });
    (0, _defineProperty2["default"])(this, "task", function (name, prerequisites, recipe) {
      if (prerequisites instanceof Function) {
        recipe = prerequisites;
        prerequisites = null;
      }

      if (!prerequisites && !recipe) {
        var _target4 = _this.taskResources.get(name);

        var result = _target4 ? _this.rules.get(_target4) : null;
        if (!result) throw new Error("No task named ".concat(name, " exists"));
        return result;
      }

      if (_this.taskResources.has(name)) throw new Error("A task named ".concat(name, " already exists"));
      var target = new _TaskResource["default"]({
        name: name,
        promake: _this
      });

      _this.taskResources.set(name, target);

      var rule = new _LastModifiedRule["default"]({
        promake: _this,
        targets: [target],
        prerequisites: prerequisites ? _this._normalizePrerequisites(prerequisites) : [],
        recipe: recipe
      });

      _this.rules.set(target, rule);

      return rule;
    });
    (0, _defineProperty2["default"])(this, "printUsage", function () {
      var _require = require('./packageInfo'),
          version = _require.version,
          homepage = _require.homepage;

      var tasks = (0, _toConsumableArray2["default"])(_this.taskResources.keys()).sort();
      var taskColumnWidth = Math.max.apply(Math, [16].concat((0, _toConsumableArray2["default"])(tasks.map(function (name) {
        return name.length;
      })))) + 2;
      process.stderr.write("promake CLI, version ".concat(version, "\n").concat(homepage, "/tree/v").concat(version, "\n\nUsage:\n  ./<script> [options...] [tasks...]\n\nOptions:\n  -q, --quiet       suppress output\n  -v, --verbose     verbose output\n\nTasks:\n  ").concat(tasks.map(function (task) {
        return "".concat((0, _lodash["default"])(task, taskColumnWidth)).concat(_this.task(task).description() || '');
      }).join('\n  ') || '(No tasks defined)', "\n"));
    });
    (0, _defineProperty2["default"])(this, "cli", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
      var argv,
          options,
          ruleArgsMode,
          _targets,
          lastTarget,
          i,
          _i,
          _targets2,
          _target5,
          _args3 = arguments;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              argv = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : process.argv;
              options = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
              ruleArgsMode = false;
              _context3.prev = 3;
              argv = argv.slice(2);
              _targets = [];
              i = 0;

            case 7:
              if (!(i < argv.length)) {
                _context3.next = 41;
                break;
              }

              if (!ruleArgsMode) {
                _context3.next = 12;
                break;
              }

              if (argv[i] === '--') {
                ruleArgsMode = false;
              } else if (lastTarget) {
                _this.rule(lastTarget).args.push(argv[i].replace(/^--(-+)$/, '$1'));
              }

              _context3.next = 38;
              break;

            case 12:
              if (!argv[i].startsWith('-')) {
                _context3.next = 27;
                break;
              }

              if (!lastTarget) {
                _context3.next = 17;
                break;
              }

              if (argv[i] === '--') {
                _this.rule(lastTarget).args = [];
                ruleArgsMode = true;
              } else {
                _this.rule(lastTarget).args.push(argv[i]);
              }

              _context3.next = 25;
              break;

            case 17:
              _context3.t0 = argv[i];
              _context3.next = _context3.t0 === '-q' ? 20 : _context3.t0 === '--quiet' ? 20 : _context3.t0 === '-v' ? 22 : _context3.t0 === '--verbose' ? 22 : 24;
              break;

            case 20:
              _this.verbosity = _Verbosity["default"].QUIET;
              return _context3.abrupt("break", 25);

            case 22:
              _this.verbosity = _Verbosity["default"].HIGH;
              return _context3.abrupt("break", 25);

            case 24:
              throw new Error("unrecognized option: ".concat(argv[i]));

            case 25:
              _context3.next = 38;
              break;

            case 27:
              _context3.prev = 27;

              _targets.push(lastTarget = _this._normalizeName(argv[i]));

              _context3.next = 38;
              break;

            case 31:
              _context3.prev = 31;
              _context3.t1 = _context3["catch"](27);

              if (!lastTarget) {
                _context3.next = 37;
                break;
              }

              _this.rule(lastTarget).args.push(argv[i]);

              _context3.next = 38;
              break;

            case 37:
              throw _context3.t1;

            case 38:
              i++;
              _context3.next = 7;
              break;

            case 41:
              if (!_targets.length) _this.printUsage();
              _i = 0, _targets2 = _targets;

            case 43:
              if (!(_i < _targets2.length)) {
                _context3.next = 50;
                break;
              }

              _target5 = _targets2[_i];
              _context3.next = 47;
              return _this.make(_target5);

            case 47:
              _i++;
              _context3.next = 43;
              break;

            case 50:
              if (options.exit !== false) process.exit(0);
              _context3.next = 57;
              break;

            case 53:
              _context3.prev = 53;
              _context3.t2 = _context3["catch"](3);

              if (options.exit !== false) {
                _this.log(_Verbosity["default"].DEFAULT, _context3.t2.stack);

                process.exit(1);
              }

              throw _context3.t2;

            case 57:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[3, 53], [27, 31]]);
    })));
  }

  (0, _createClass2["default"])(Promake, null, [{
    key: "checkResource",
    value: function checkResource(resource, path) {
      if (typeof resource === 'string') return;

      if (!(resource instanceof Object)) {
        throw new Error('Resource must be a string or conform to the Resource interface');
      }

      if (typeof resource.lastModified !== 'function') {
        throw new Error('resource ');
      }
    }
  }]);
  return Promake;
}();

exports["default"] = Promake;
(0, _defineProperty2["default"])(Promake, "VERBOSITY", _Verbosity["default"]);
module.exports = exports.default;