"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RuleType = exports.default = void 0;

var _ExecutionContext = _interopRequireDefault(require("./ExecutionContext"));

var t = _interopRequireWildcard(require("typed-validators"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class Rule {
  constructor(props) {
    _defineProperty(this, "args", []);

    _defineProperty(this, "runAtLeastOnce", false);

    _defineProperty(this, "_make", async (context) => {
      throw new Error('not implemented, this is an abstract class');
    });

    _defineProperty(this, "make", (context = new _ExecutionContext.default()) => {
      return context.make(this, this._make);
    });

    _defineProperty(this, "then", (onResolve, onReject) => this.make().then(onResolve, onReject));

    _defineProperty(this, "catch", onReject => this.make().catch(onReject));

    _defineProperty(this, "finally", onSettled => this.make().finally(onSettled));

    _defineProperty(this, "description", function (newDescription) {
      if (!arguments.length) return this._description;
      this._description = newDescription;
      return this;
    }.bind(this));

    Object.assign(this, props);
  }

  toString() {
    if (this.targets.length > 1) return `${String(this.targets[0])} (+${this.targets.length} more)`;
    return String(this.targets[0]);
  }

  inspect() {
    return this.toString();
  }

}

exports.default = Rule;
const RuleType = t.alias('Rule', t.instanceOf(() => Rule));
exports.RuleType = RuleType;