"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = handleChildProcessCleanup;

var _Verbosity = _interopRequireDefault(require("./Verbosity"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var killCount = 0;
var runningProcesses = new Set();

function handleChildProcessCleanup(promake, child) {
  function die() {
    process.off('SIGINT', killHandler);
    process.kill(process.pid, 'SIGINT');
  }

  function killHandler() {
    killCount++;
    if (killCount === 1) promake.log(_Verbosity["default"].DEFAULT, 'cleaning up, please wait...');else promake.log(_Verbosity["default"].QUIET, 'got second SIGINT, killing spawned processes with SIGKILL');

    var _iterator = _createForOfIteratorHelper(runningProcesses),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _child = _step.value;

        _child.kill(killCount > 1 ? 'SIGKILL' : 'SIGINT');
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    if (killCount > 1) die();
  }

  if (!runningProcesses.size) {
    process.on('SIGINT', killHandler);
  }

  runningProcesses.add(child);

  var cleanupChild = function cleanupChild() {
    child.removeListener('close', cleanupChild);
    child.removeListener('error', cleanupChild);
    runningProcesses["delete"](child);

    if (!runningProcesses.size) {
      process.off('SIGINT', killHandler);
      if (killCount) die();
    }
  };

  child.once('close', cleanupChild);
  child.once('error', cleanupChild);
}

module.exports = exports.default;